package com.memorynotfound.jsf;

import javax.faces.component.FacesComponent;
import javax.faces.component.UIOutput;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import javax.faces.event.*;
import java.io.IOException;

@FacesComponent(value = "com.memorynotfound.myOutput")
@ListenersFor({
        @ListenerFor(systemEventClass=PostAddToViewEvent.class),
        @ListenerFor(systemEventClass=PostConstructViewMapEvent.class)
})
public class MyOutput extends UIOutput {

    public void processEvent(ComponentSystemEvent event) throws AbortProcessingException {
        super.processEvent(event);
        System.out.println("process event - " + event.toString());
    }

    @Override
    public void encodeEnd(FacesContext context) throws IOException {
        ResponseWriter responseWriter = context.getResponseWriter();
        responseWriter.write((String)getValue());
    }

}
